#include "imagehandler.h"

#include <QGraphicsObject>
#include <QStyleOptionGraphicsItem>

#include <QQuickItem>

#include <QImage>
#include <QPainter>
#include <QDebug>

ImageHandler::ImageHandler(QObject *parent) :
    QObject(parent)
{
}

QImage ImageHandler::extractQImage(QObject *imageUrl,
                                   const double offsetX, const double offsetY,
                                   const double width, const double height)
{

    qDebug() << "[extractQImage] Image URL:" << imageUrl;

    //QImage img()

    return QImage();

    QGraphicsObject *item = qobject_cast<QGraphicsObject*>(imageUrl);

    if (!item) {
        qDebug() << "Item:" << item;
        qDebug() << "Item is NULL";
        return QImage();
    }

    // Get the size of the QGraphicsObject and use it to construct a
    // QImage container of the same size
    QImage img(item->boundingRect().size().toSize(), QImage::Format_RGB32);
    // Fill in the image
    img.fill(QColor(255, 255, 255).rgb());

    /**/
    QPainter painter(&img);
    QStyleOptionGraphicsItem styleOption;
    item->paint(&painter, &styleOption);
    /**/

    if(offsetX == 0 && offsetY == 0 && width == 0 && height == 0)
        return img;
    else
    {
        return img.copy(offsetX, offsetY, width, height);
    }
}

void ImageHandler::save(QObject *imageObj, const QString &path,
                        const double offsetX, const double offsetY,
                        const double width, const double height)
{
    QImage img = extractQImage(imageObj, offsetX, offsetY, width, height);
    img.save(path);
}
